set _CHIPNAME lpc4333

#-- jtag init modified based on target/lpc4350.cfg

adapter_khz 2000

set _M4_JTAG_TAPID 0x4ba00477
set _M0_JTAG_TAPID 0x0ba01477

jtag newtap $_CHIPNAME m4 -irlen 4 -ircapture 0x1 -irmask 0xf -expected-id $_M4_JTAG_TAPID
jtag newtap $_CHIPNAME m0 -irlen 4 -ircapture 0x1 -irmask 0xf -expected-id $_M0_JTAG_TAPID

target create $_CHIPNAME.m4 cortex_m -chain-position $_CHIPNAME.m4
#target create $_CHIPNAME.m0 cortex_m -chain-position $_CHIPNAME.m0

cortex_m reset_config vectreset

#-- jtag init end

# Cortex-M4 core reset.
# This should be called after writing flash, without it I needed to power cycle LPC43xx after each run.
# Do not call this at reset-init.
proc core_reset {} {
    mww 0x40053100 1
    sleep 10
}

$_CHIPNAME.m4 configure -event reset-init {

    echo "LPC43xx reset-init: started"

if 1 {
    # Set system clock to Internal 12 MHz oscillator
    mww 0x4005006C 0x01000000 ;# BASE_M4_CLK

    # Set all other clocks to Internal 12 MHz oscillator
    mww 0x40050060 0x01000000 ;# BASE_USB0_CLK
    mww 0x40050064 0x01000000 ;# BASE_PERIPH_CLK - only LPC4370
    mww 0x40050068 0x01000000 ;# BASE_USB1_CLK
    mww 0x40050070 0x01000000 ;# BASE_SPIFI_CLK
    mww 0x40050074 0x01000000 ;# BASE_SPI_CLK
    mww 0x40050078 0x01000000 ;# BASE_PHY_RX_CLK
    mww 0x4005007C 0x01000000 ;# BASE_PHY_TX_CLK
    mww 0x40050080 0x01000000 ;# BASE_APB1_CLK
    mww 0x40050084 0x01000000 ;# BASE_APB3_CLK
    mww 0x40050088 0x01000000 ;# BASE_LCD_CLK
    mww 0x4005008C 0x01000000 ;# BASE_ADCHS_CLK
    mww 0x40050090 0x01000000 ;# BASE_SDIO_CLK
    mww 0x40050094 0x01000000 ;# BASE_SSP0_CLK
    mww 0x40050098 0x01000000 ;# BASE_SSP1_CLK
    mww 0x4005009C 0x01000000 ;# BASE_UART0_CLK
    mww 0x400500A0 0x01000000 ;# BASE_UART1_CLK
    mww 0x400500A4 0x01000000 ;# BASE_UART2_CLK
    mww 0x400500A8 0x01000000 ;# BASE_UART3_CLK
    mww 0x400500AC 0x01000000 ;# BASE_OUT_CLK
    mww 0x400500C0 0x01000000 ;# BASE_AUDIO_CLK
    mww 0x400500C4 0x01000000 ;# BASE_CGU_OUT0_CLK
    mww 0x400500C8 0x01000000 ;# BASE_CGU_OUT1_CLK
    }

if 1 {
    # Enable clock branches in CCU
#    mww 0x40051100 1 ;# APB3 BUS
#    mww 0x40051108 1 ;# APB3 I2C1
#    mww 0x40051110 1 ;# APB3 DAC
#    mww 0x40051118 1 ;# APB3 ADC0
#    mww 0x40051120 1 ;# APB3 ADC1
#    mww 0x40051128 1 ;# APB3 CAN0
#    mww 0x40051200 1 ;# APB1 BUS 
#    mww 0x40051208 1 ;# APB1 MOTOCON
#    mww 0x40051210 1 ;# APB1 I2C0
#    mww 0x40051218 1 ;# APB1 I2S
#    mww 0x40051220 1 ;# APB1 CAN1
    mww 0x40051300 1 ;# SPIFI
    mww 0x40051400 1 ;# M4 BUS
    mww 0x40051408 1 ;# M4 SPIFI
    mww 0x40051410 1 ;# M4 GPIO
#    mww 0x40051418 1 ;# M4 LCD
#    mww 0x40051420 1 ;# M4 ETHERNET
#    mww 0x40051428 1 ;# M4 USB0
    mww 0x40051430 1 ;# M4 EMC
#    mww 0x40051438 1 ;# M3 SDIO
    mww 0x40051440 1 ;# M4 DMA
    mww 0x40051448 1 ;# M4 CORE
    mww 0x40051468 1 ;# M4 SCT
#    mww 0x40051470 1 ;# M4 USB1
    mww 0x40051478 1 ;# M4 EMCDIV
    mww 0x40051480 1 ;# M4 FLASHA
    mww 0x40051488 1 ;# M4 FLASHB
    mww 0x40051490 1 ;# M4 M0APP
#    mww 0x40051498 1 ;# M4 ADCHS
    mww 0x400514A0 1 ;# M4 EEPROM
    mww 0x40051500 1 ;# M4 WWDT
    mww 0x40051508 1 ;# M4 UART0
    mww 0x40051510 1 ;# M4 UART1
#    mww 0x40051518 1 ;# M4 SSP0
    mww 0x40051520 1 ;# M4 TIMER0
    mww 0x40051528 1 ;# M4 TIMER1
    mww 0x40051530 1 ;# M4 SCU
    mww 0x40051538 1 ;# M4 CREG
    mww 0x40051600 1 ;# M4 RITIMER
    mww 0x40051608 1 ;# M4 UART2
    mww 0x40051610 1 ;# M4 UART3
    mww 0x40051618 1 ;# M4 TIMER2
    mww 0x40051620 1 ;# M4 TIMER3
#    mww 0x40051628 1 ;# M4 SSP1
#    mww 0x40051630 1 ;# M4 QEI
    # Skipped: 0x400517xx (M0SUB aka PERIPH, only in LPC4370)
#    mww 0x40051800 1 ;# USB0
#    mww 0x40051900 1 ;# USB1
#    mww 0x40051A00 1 ;# SPI
#    mww 0x40051B00 1 ;# ADCHS
#    mww 0x40052100 1 ;# AUDIO
    mww 0x40052200 1 ;# UART3
    mww 0x40052300 1 ;# UART2
    mww 0x40052400 1 ;# UART1
    mww 0x40052500 1 ;# UART0
#    mww 0x40052600 1 ;# SSP1
#    mww 0x40052700 1 ;# SSP0
#    mww 0x40052800 1 ;# SDIO
    }

    echo "LPC43xx reset-init: done"
}

set _CCLK 12000

#A large working area greatly reduces flash write times
set _WORKAREASIZE 0x8000

$_CHIPNAME.m4 configure -work-area-phys 0x10000000 -work-area-size $_WORKAREASIZE

# flash bank <name> lpc2000 <base> <size> 0 0 <target#> <variant> <clock> [calc checksum]
flash bank FLASH_A lpc2000 0x1A000000 0x40000 0 0 $_CHIPNAME.m4 lpc4300 $_CCLK calc_checksum
flash bank FLASH_B lpc2000 0x1B000000 0x40000 0 0 $_CHIPNAME.m4 lpc4300 $_CCLK calc_checksum
